-- Global Variables
allOk = true
cellReached = false
guidePositionReached = false
prisonerReachedLock = false
hangarReached = false


-- Returns the distance between (x1,x2,x3) and (y1,y2,y3)
function dist( x1,x2,x3, y1,y2,y3 )
return math.sqrt( (x1-y1)^2 + (x2-y2)^2 + (x3-y3)^2 )
end


function observeGuard()
guardX = guard:getAbsCoorX()
guardY = guard:getAbsCoorY()
guardZ = guard:getAbsCoorZ()

if dist( guardX,guardY,guardZ,35.48, 29, 191.28 ) < 60 then
allOk = false
end

end

function observePrisoner()

prisonerX = Prisoner:getAbsCoorX()
prisonerY = Prisoner:getAbsCoorY()
prisonerZ = Prisoner:getAbsCoorZ()

if dist( prisonerX,prisonerY,prisonerZ,161.76,49,358.87 ) < 60 then
prisonerReachedLock = true
end

end

cellProgrammed = false
function goToCell(timestep)

if not cellProgrammed then
--io.write("Guard called \n")
secondguard:walkTo(-132, 29, 238.381805)
secondguard:walkTo(-138.41, 29, 275.25)
secondguard:walkTo(-143.70, 29, 275.35)
secondguard:walkTo(-149.10, 29, 226.66)
secondguard:walkTo(-149.10, 29, 196.83)
secondguard:walkTo(-145.82, 29, 189.74)
secondguard:walkTo(-138.48, 29, 184.28)
secondguard:walkTo(35.48, 29, 191.28)
secondguard:runTo(102, 29, 203.28)
secondguard:runTo(164, 29, 245.28)

cellProgrammed = true
end

if secondguard:finalGoalReached() then
return true
end

return false
end

guideProgrammed = false
function goToGuidePosition(timestep)

if not guideProgrammed then
--io.write("Guard called \n")
secondguard:walkTo(-132, 29, 238.381805)
secondguard:walkTo(-138.41, 29, 275.25)
secondguard:walkTo(-143.70, 29, 275.35)
secondguard:walkTo(-149.10, 29, 226.66)
secondguard:walkTo(-149.10, 29, 196.83)
secondguard:walkTo(-145.82, 29, 189.74)
secondguard:walkTo(-138.48, 29, 184.28)
secondguard:walkTo(35.48, 29, 191.28)
secondguard:runTo(102, 29, 203.28)
secondguard:runTo(164, 29, 245.28)

guideProgrammed = true
end

if secondguard:finalGoalReached() then
return true
end

return false
end

hangarProgrammed = false
function goToHangar(timestep)

if not hangarProgrammed then
--io.write("Guard called \n")
secondguard:walkTo(-132, 29, 238.381805)
secondguard:walkTo(-138.41, 29, 275.25)
secondguard:walkTo(-143.70, 29, 275.35)
secondguard:walkTo(-149.10, 29, 226.66)
secondguard:walkTo(-149.10, 29, 196.83)
secondguard:walkTo(-145.82, 29, 189.74)
secondguard:walkTo(-138.48, 29, 184.28)
secondguard:walkTo(35.48, 29, 191.28)
secondguard:runTo(102, 29, 203.28)
secondguard:runTo(164, 29, 245.28)

hangarProgrammed = true
end

if secondguard:finalGoalReached() then
return true
end

return false

end

function tick(timestep)
--io.write("Secondguard called \n")
 
observePrisoner()

if not allOk then
cellReached = goToCell(timestep)
end

if cellReached and not guidePositionReached then
guidePositionReached = goToGuidePosition(timestep)
end

if guidePositionReached and prisonerReachedLock then
hangarReached = goToHangar(timestep)
end

if hangarReached then
return true
end

return false
end